﻿--转移操作表增加 单据编号、单据分录序号
IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_MSMOD_RESERVEREPLACE_OP' AND KSQL_COL_NAME ='FBILLNO') 
 ALTER TABLE T_MSMOD_RESERVEREPLACE_OP ADD (FBILLNO NVARCHAR(50) DEFAULT ' ' NOT NULL);
IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_MSMOD_RESERVEREPLACE_OP' AND KSQL_COL_NAME ='FBILLENTRYSEQ') 
 ALTER TABLE T_MSMOD_RESERVEREPLACE_OP ADD (FBILLENTRYSEQ BIGINT DEFAULT 0 NOT NULL );
 
--预留释放记录增加 单据编号、供应对象、供应ID、总量预留ID
IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_MSMOD_RELEASE_RECORD' AND KSQL_COL_NAME ='FBILLNO') 
 ALTER TABLE T_MSMOD_RELEASE_RECORD ADD (FBILLNO NVARCHAR(50) DEFAULT ' ' NOT NULL);
 IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_MSMOD_RELEASE_RECORD' AND KSQL_COL_NAME ='FBAL_OBJ_ID') 
 ALTER TABLE T_MSMOD_RELEASE_RECORD ADD (FBAL_OBJ_ID NVARCHAR(50) DEFAULT ' ' NOT NULL);
 IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_MSMOD_RELEASE_RECORD' AND KSQL_COL_NAME ='FBALID') 
 ALTER TABLE T_MSMOD_RELEASE_RECORD ADD (FBALID BIGINT DEFAULT 0 NOT NULL );
 IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_MSMOD_RELEASE_RECORD' AND KSQL_COL_NAME ='FAGGREGATEID') 
 ALTER TABLE T_MSMOD_RELEASE_RECORD ADD (FAGGREGATEID BIGINT DEFAULT 0 NOT NULL );

--预留转移记录表增加 单据编号、单据分录序号
IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_MSMOD_RESERVETRANS' AND KSQL_COL_NAME ='FBILLNO') 
 ALTER TABLE T_MSMOD_RESERVETRANS ADD (FBILLNO NVARCHAR(50) DEFAULT ' ' NOT NULL);
IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_MSMOD_RESERVETRANS' AND KSQL_COL_NAME ='FBILLENTRYSEQ') 
 ALTER TABLE T_MSMOD_RESERVETRANS ADD (FBILLENTRYSEQ BIGINT DEFAULT 0 NOT NULL );

 
--增加预留操作日志表 
IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_MSMOD_RESERVE_OPLOG') 
 CREATE TABLE T_MSMOD_RESERVE_OPLOG (
 FID BIGINT DEFAULT 0 NOT NULL,
 FRESERVERECORDID BIGINT DEFAULT 0 NOT NULL,
 FBILLOBJ NVARCHAR(50) DEFAULT ' ' NOT NULL, 
 FBILLID BIGINT DEFAULT 0 NOT NULL, 
 FBILLNO NVARCHAR(50) DEFAULT ' ' NOT NULL,
 FBILLENTRYID BIGINT DEFAULT 0 NOT NULL, 
 FBILLENTRYSEQ BIGINT DEFAULT 0 NOT NULL, 
 FBAL_OBJ_ID NVARCHAR(50) DEFAULT ' ' NOT NULL, 
 FBALID BIGINT DEFAULT 0 NOT NULL, 
 FBASEQTY DECIMAL(23,10) DEFAULT 0 NOT NULL,
 FQTY DECIMAL(23,10) DEFAULT 0 NOT NULL,
 FQTY2ND DECIMAL(23,10) DEFAULT 0 NOT NULL,
 FOP NVARCHAR(50) DEFAULT ' ' NOT NULL,
 FOPTYPE NVARCHAR(50) DEFAULT ' ' NOT NULL,
 FCREATERID BIGINT DEFAULT 0 NOT NULL,
 FCREATEDATE DATETIME,
 FTRACEID NVARCHAR(50) DEFAULT ' ' NOT NULL
);

EXEC P_ALTERPK 'PK_MSMOD_RESERVE_OPLOG', 'T_MSMOD_RESERVE_OPLOG', 'FID', '1';
 
IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_MSMOD_RESERVELOG_CREATEDATE') CREATE INDEX IDX_MSMOD_RESERVELOG_CREATEDATE ON T_MSMOD_RESERVE_OPLOG (FCREATEDATE);
IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_MSMOD_RESERVELOG_BILLNO') CREATE INDEX IDX_MSMOD_RESERVELOG_BILLNO ON T_MSMOD_RESERVE_OPLOG (FBILLOBJ,FBILLNO);
IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_MSMOD_RESERVELOG_BALID') CREATE INDEX IDX_MSMOD_RESERVELOG_BALID ON T_MSMOD_RESERVE_OPLOG (FBALID);

IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_MSMOD_RESERVE_OPLOG' AND KSQL_COL_NAME ='FTRACEID') 
 ALTER TABLE T_MSMOD_RESERVE_OPLOG ADD (FTRACEID NVARCHAR(50) DEFAULT ' ' NOT NULL );